#!/usr/bin/tclsh
;# This is called when a server receives a connection

set server [ lindex $argv 0 ]
set remote_port [ lindex $argv 1 ]

if { ! [ regexp {[A-Za-z0-9.-]} $server ] } {
	set server 127.0.0.1
}
if { ! [ string is integer -strict $remote_port ] } {
	set remote_port 33000
}
puts "Connecting to server=$server, port=$remote_port"

set sock [socket $server $remote_port]

set local_port [ lindex [ fconfigure $sock -sockname ] 2 ]
puts $local_port
#
# Client write to socket...
fconfigure $sock -buffersize 25600 -blocking 1 -buffering full

while { ! [ eof $sock ] } {
	set line [ gets $sock ]
	after 20
	puts $line
}

} 

catch {close $sock}
