#!/usr/bin/perl

use strict;
use Time::HiRes 'gettimeofday';
use IO::Handle;

my %timeouts;
my $sport;
my $detail;
my $timeout;
my $delta;
my $state;
my $seconds;
my $microseconds;
my ($H,$M,$S);
my $nl;

$|=1;

while (1) {
	open(CONNTRACK,"/proc/net/ip_conntrack") or die;
	while(<CONNTRACK>) {
		chomp;
		if ( /^tcp +[0-9]+ +([0-9]+) +([A-Z_]+) (.*sport=([0-9]+) dport=33000)/i ) {
			$timeout=$1;
			$state=$2;
			$sport=$4;
			$detail=$3;
			if( $timeouts{$sport} != $timeout ) {
				$delta = $timeouts{$sport} - $timeout;
				$timeouts{$sport} = $timeout;
				($seconds,$microseconds) = gettimeofday();
				($S,$M,$H,) = localtime($seconds);
				if( $state eq "ESTABLISHED" && ( $timeout > 431996 || ( $timeout < 300 && $timeout > 296 ) )  || abs($delta) > 1 ) {
					printf("$nl%02d:%02d:%02d.%03d %06d %-9s %s\n",$H,$M,$S,$microseconds/1000,$timeout,$state,$detail);
					$nl="";
				} elsif ( $state eq "ESTABLISHED" ) {
					$nl="\n";
					printf(".");
				}
			}
		}
	}
}
