#!/usr/bin/tclsh

set my_port 33000

proc serverOpen {channel addr port} {
    global connected
    set connected 1
    fileevent $channel readable "readLine $channel"
    fileevent $channel writable "dump_to_client_once $channel"
    puts "OPENED $channel"
    fconfigure $channel -buffering none -blocking 0
    #fconfigure $channel  -buffersize 65536
}

proc dump_to_client {channel} {
    for { set i 1} { $i<=50 } { incr i } {
	    puts $channel [ format "This is line number %-60s %05d" "..." $i ]
	    flush $channel
    }
}

proc dump_to_client_once {channel} {
	fileevent $channel writable {}
	dump_to_client $channel
}

proc readLine {channel} {
    global didRead  
    global exit_server  
    
    gets $channel line;
    puts "Received: $line"
    puts $channel "Received: $line"
    flush $channel
    if { [ string first {dump} $line ] >= 0 } {
	dump_to_client $channel
    } elseif { [ string first {exit} $line ] >= 0 } {
	set exit_server 1;
    }
    set didRead 1
    if {[ eof $channel ]} {
            fileevent $channel readable {}
	    puts "Closing $channel"
            after idle "close $channel;set out 1"
    } 
}

set connected 0;

set server [socket -server serverOpen $my_port]

after 100 update;

vwait exit_server;;

close $server
